extern char *malloc(), *realloc();

# line 9 "ypp.y"
static int exdebug = 0;

#include "ypp.h"
#include "head.h"

/*
#define YYDEBUG 6
#define YYDEBUG_LEXER_TEXT yytext
*/

extern char* get_act ();

int node_max = 0;

struct cRule {
	int tok;
	int np;
	int nrb[MAXPROD];
	Rbody rb[MAXPROD][MAXRBODY];
	char *act[MAXPROD];
	int sys_act[MAXPROD];
} cR;

struct cDecl {
	int ndecl;
	int decl[MAXPROD * MAXRBODY];
	int num[MAXPROD * MAXRBODY];
} cD;


# line 40 "ypp.y"
typedef union  {
	int num;
	char *str;
	Exte *exte;
} YYSTYPE;
# define IDENTIFIER 257
# define C_IDENTIFIER 258
# define L_IDENTIFIER 259
# define STRING 260
# define KLIST 261
# define NUMBER 262
# define LEFT 263
# define RIGHT 264
# define NONASSOC 265
# define TOKEN 266
# define PREC 267
# define TYPE 268
# define START 269
# define UNION 270
# define MARK 271
# define LCURL 272
# define RCURL 273
# define EOSTRING 274
# define ENPSTRING 275
# define EASTRING 276
# define EDSTRING 277
# define ENSTRING 278
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 307 "ypp.y"


yywrap()
{
    return 1;
}

add_rbody (str, type)
char *str;
int type;
{
	struct cRule *r = &cR;
	int ln = r->np;
	int lnr = r->nrb[ln];
	Rbody *rb = &r->rb[ln][lnr];
	char *sym = to_symbol (str);
	int ltok;

	rb->type = type;

	if (type == ACT) {
		rb->act = str;
	}
	else {
		if ((ltok = get_symbol (sym)) > 0)
			rb->tok = ltok;
		else
			rb->tok = install (sym);
	}

	if (type != ACT)
		rb->num = check_no_repeat_name (rb->tok);

	r->nrb[ln]++;
}

niy (str)
char *str;
{
	sprintf (serr, "NIY: %s", str);
	fatal (serr);
}

rule_init (str, ext)
char *str;
Exte *ext;
{
	int i, ltok;
	char *sym = to_symbol (str);

	init_cR ();
	if ((ltok = get_symbol (sym)) < 0) {
		symbol[tok] = str;
		Symbol[tok] = to_Symbol (str);
		type[tok] = NONTERM;
		E[tok] = ext;
		cR.tok = tok;

			if (exdebug)
				show_entry ("rule_init", tok);

		tok++;
	}
	else {
		type[ltok] = NONTERM;
		E[ltok] = ext;
		cR.tok = ltok;
	}
}

not_decl (ltok, num)
int ltok, num;
{
	int i, inum = 0;

	for (i = 0; i < cD.ndecl; i++) {
		if (ltok == cD.decl[i])
			if (num == inum)
				return 0;
			else
				inum++;
	}

	cD.num[cD.ndecl] = num;
	return cD.decl[cD.ndecl++] = ltok;
}

dump_treeh_decl ()
{
	int i, j, n;
	char *id;
	int num_id;
	Rule *r;
	Rbody *rb;
	Decl *d;
	Exte *e;

	for (n = 0; n < tok; n++) {
		if (is_notdecsym (n))
			continue;

		d = D[n];
		r = R[n];
		e = E[n];

		fprintf (fd_treeh, "struct S_%s {\n", symbol[n]);
		fprintf (fd_treeh, "\tint type;\n");
		fprintf (fd_treeh, "\tchar *str;\n");
		fprintf (fd_treeh, "\tstruct Typ *typ;\n");
		fprintf (fd_treeh, "\tstruct Trans *trans;\n");
		fprintf (fd_treeh, "#ifdef CHECK\n");
		fprintf (fd_treeh, "\tunsigned attr_check: 1;\n");
		fprintf (fd_treeh, "\tunsigned attr_trans: 1;\n");
		fprintf (fd_treeh, "\tunsigned attr_write: 1;\n");
		fprintf (fd_treeh, "\tunsigned attr_rest: 29;\n");
		fprintf (fd_treeh, "#endif\n");

		if (d != (Decl*) 0) {
			for (j = 0; j < d->ndecl; j++)
				if (d->num[j])
					fprintf (fd_treeh,
				            "\tunion Node *%s%d;\n", symbol[d->decl[j]], d->num[j]);
				else
					fprintf (fd_treeh, "\tunion Node *%s;\n", symbol[d->decl[j]]);
		}

		if (e != (Exte*) 0 && e->add != (char*) 0)
			fprintf (fd_treeh, "\t%s", e->add);
	
		fprintf (fd_treeh, "};\n\n");
	}
}

check_no_repeat_name (ltok)
int ltok;
{
	int i, num = 0;
	char *id;
	struct cRule *r = &cR;

	for (i = 0; i < r->nrb[r->np]; i++) {
		id = symbol[r->rb[r->np][i].tok];
		if (*id != '\'') {
			if (ltok == r->rb[r->np][i].tok)
				num++;
		}
		else {
			sprintf (serr, "check_no_repeat_name: %s", symbol[ltok]);
			fatal (serr);
		}
	}

	return num;
}

dump_treeh_rest ()
{
	int i, unit;

	for (i = 0; i < tok; i++) {
		unit = i % fd_treec_max;

		if (type[i] != UNDEF && is_notdecsym (i) && is_notusedef (i)
		                     && type[i] != NONTERM) {
			fprintf (fd_treeh, "extern union Node %s;\n", symbol[i]);
			if (Lymbol[i] == (char*) 0 || *Lymbol[i] == '\'')
				fprintf (fd_treec [unit], "static struct S_def %s_S = {%s, (char*) 0};\n"
				                 , symbol[i], Symbol[i]);
			else
				fprintf (fd_treec [unit], "static struct S_def %s_S = {%s, %s};\n"
				                 , symbol[i], Symbol[i], Lymbol[i]);
			fprintf (fd_treec [unit], "Node %s;\n", symbol[i]);
		}
	}

	fprintf (fd_treec [0], "\nTree_init_constants ()\n{\n");
	for (i = 0; i < fd_treec_max; i++)
		fprintf (fd_treec [0], "\tTree_init_constants_%d ();\n", i);
	fprintf (fd_treec [0], "}\n\n");

	for (i = 0; i < fd_treec_max; i++)
		fprintf (fd_treec [i], "\nTree_init_constants_%d ()\n{\n", i);

	for (i = 0; i < tok; i++) {
		unit = i % fd_treec_max;

		if (type[i] != UNDEF && is_notdecsym (i) && is_notusedef (i)
		                     && type[i] != NONTERM) {
			fprintf (fd_treec [unit], "\t%s.def = %s_S;\n", symbol[i], symbol[i]);
			fprintf (fd_output, "#define o%s() write_pass (&%s)\n", Symbol [i], symbol [i]);
		}
	}

	for (i = 0; i < fd_treec_max; i++)
		fprintf (fd_treec [i], "}\n\n");

	fprintf (fd_treeh, "\n#define NODE_MAX %d\n\n", node_max);

	fprintf (fd_treeh, "struct S_com {\n");
	fprintf (fd_treeh, "\tint type;\n");
	fprintf (fd_treeh, "\tchar *str;\n");
	fprintf (fd_treeh, "\tstruct Typ *typ;\n");
	fprintf (fd_treeh, "\tstruct Trans *trans;\n");
	fprintf (fd_treeh, "#ifdef CHECK\n");
	fprintf (fd_treeh, "\tunsigned attr_check: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_trans: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_write: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_rest: 29;\n");
	fprintf (fd_treeh, "#endif\n");
	fprintf (fd_treeh, "\tunion Node *node[NODE_MAX];\n");
	fprintf (fd_treeh, "};\n\n");

	fprintf (fd_treeh, "struct S_def {\n");
	fprintf (fd_treeh, "\tint type;\n");
	fprintf (fd_treeh, "\tchar *str;\n");
	fprintf (fd_treeh, "\tstruct Typ *typ;\n");
	fprintf (fd_treeh, "\tstruct Trans *trans;\n");
	fprintf (fd_treeh, "#ifdef CHECK\n");
	fprintf (fd_treeh, "\tunsigned attr_check: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_trans: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_write: 1;\n");
	fprintf (fd_treeh, "\tunsigned attr_rest: 29;\n");
	fprintf (fd_treeh, "#endif\n");
	fprintf (fd_treeh, "};\n\n");

	fprintf (fd_treeh, "typedef union Node {\n");
	fprintf (fd_treeh, "\tstruct S_def def;\n");
	fprintf (fd_treeh, "\tstruct S_com com;\n");
	fprintf (fd_treeh, "\tstruct S_lst lst;\n");

	for (i = 0; i < tok; i++)
		if (is_decsym (i))
			fprintf (fd_treeh, "\tstruct S_%s %s;\n", symbol[i], symbol[i]);
	fprintf (fd_treeh, "} Node;\n");
}	

dump_all ()
{
	dump_defs ();
	dump_rules ();
}

dump_defs ()
{
	int i;

	printf ("%%union {int integer; Node *node;};\n\n");

	for (i = 0; i < tok; i++)
		if (type[i] == TERM) {
			if (is_usedef (i))
				printf ("%%token<node> %-25s %4d\n", Symbol[i], i);
			else
				printf ("%%token<integer> %-25s %4d\n", Symbol[i], i);
		}
		else if (type[i] == LIT)
			printf ("%%type<integer> '%c'\n", i);

    printf ("\n");
    for (i = 0; i < tok; i++)
		if (type[i] == NONTERM) {
			if (E[i] != (Exte*) 0 && E[i]->np)
				continue;

			printf ("%%type<node> %-25s\n", symbol[i]);
		}

	printf ("\n%%%%\n");
}

dump_rules ()
{
	dump_y ();
	dump_treeh_decl ();
	dump_treeh_rest ();
}

dump_y ()
{
	int i, j, n, typ, ltok, lltok, num;
	Rule *r;
	char fname[100], tname[100];
	int start_not_written = 1, more_than_one, sys_action;

	for (n = 0; n < tok; n++) {
		if ((r = R[n]) == (Rule*) 0)
			continue;

		if (E[n] != (Exte*) 0 && E[n]->np)
			continue;

	printf ("\n%s", symbol[r->tok]);

	more_than_one = 0;

	for (i = 0; i < r->np; i++) {

		num = 0;
		for (j = 0; j < r->nrb[i]; j++)
			if (r->rb[i][j].type != ACT)
				num++;

		if (num > 1) {
			more_than_one = 1;
			break;
		}	
	}

	if (E[n] != (Exte*) 0 && E[n]->node)
		more_than_one = 1;

	for (i = 0; i < r->np; i++) {
		sys_action = 0;
		i? printf ("\n\t|") : printf ("\n\t:");

		for (j = 0; j < r->nrb[i]; j++) {
			if (r->rb[i][j].type == ACT) {
				if (j < r->nrb[i] - 1)
					printf ("\n\t{%s}\n\t", r->rb[i][j].act);
			}
			else {
			ltok = r->rb[i][j].tok;
			switch (type[ltok]) {
			case LIST:
			case NONTERM:
				printf (" %s", symbol[ltok]);
				break;
			case TERM: printf (" %s", Symbol[ltok]); break;
			case LIT: printf (" %s", Lymbol[ltok]); break;
			default:
				sprintf (serr, "dump_y: default: ltok = %d, [%s|%s]", ltok, symbol[ltok],Symbol[ltok]);
				syserr (serr);
				break;
			}
			}
		}

		if (r->sys_act[i] == 0)
			goto skip_sys_act;

		if (r->nrb[i] == 0) {
			sys_action = 1;
			printf ("\n\t{\n");
			printf ("\t\t$$ = (Node*) 0;\n");
		}
		else if (more_than_one) {
			sys_action = 1;
			printf ("\n\t{\n");

			for (j = 0; j < r->nrb[i]; j++) {
				if (r->rb[i][j].type == ACT)
					continue;

				lltok = r->rb[i][j].tok;
				if (r->rb[i][j].num)
					sprintf (fname, "%s%d", symbol[lltok], r->rb[i][j].num);
				else
					sprintf (fname, "%s", symbol[lltok]);

				if (type[lltok] == NONTERM || is_decsym (lltok) || is_usedef (lltok))
					sprintf (tname, "$%d", j+1);
				else
					sprintf (tname, "&%s", symbol[lltok]);

				if (j == 0) {
					if (start_not_written)  /* assume that is the 'start' symbol */
						printf ("\t\ttree = $$ = make (%s);\n", Symbol[r->tok]);
					else
						printf ("\t\t$$ = make (%s);\n", Symbol[r->tok]);
				}

				printf ("\t\t$$->%s.%s = %s;\n", symbol[r->tok], fname, tname);
			}
		}
		else if (((typ = type[r->rb[i][0].tok]) == TERM || typ == LIT)
		 && (is_notdecsym (r->rb[i][0].tok) && is_notusedef (r->rb[i][0].tok))) {
			sys_action = 1;
			printf ("\n\t{\n");
			printf ("\t\t$$ = &%s;\n", symbol[r->rb[i][0].tok]);
		}
		else if (r->act[i] == (char*) 0)
			continue;

skip_sys_act:

		for (j = 0; j < r->nrb[i] - 1; j++)
			if (r->rb[i][j].type == ACT)
				if (r->rb[i][j].act == r->act[i]) {
					r->act[i] = (char*) 0;
					break;
				}

		if (r->act[i] != (char*) 0) {
			if (r->sys_act[i] == 0)
				printf ("\n\t{");
			else
				printf ("\t{");
			printf ("%s", r->act[i]);
			printf ("}\n");
		}

		if (sys_action == 1)
			printf ("\t}");
	}

	printf ("\n\t;\n");

	if (type[n] == NONTERM)
		start_not_written = 0;

	}
}

get_symbol (sym)
char *sym;
{
	int i;

	for (i = 0; i < tok; i++)
		if (type[i] != UNDEF) {
			if (!strcmp(sym, symbol[i])
			 || !strcmp(sym, Symbol[i])
			 || (i < 257 && !strcmp(sym, Lymbol[i])))
				return i;
		}

	return -1;
}

inc_nprod ()
{
	cR.np++;
	if (cR.np >= MAXPROD)
		fatal (stderr, "increment MAXPROD");
}

Decl *creat_Decl (r)
struct cRule *r;
{
	int i, j, tok = r->tok;
	Decl *d;
	Rbody *rb;

	for (i = 0; i < r->np; i++)
		if (r->nrb[i] > 1 || (E[tok] != (Exte*) 0 && E[tok]->node))
			goto declare;

	return (Decl*) 0;

declare:
	init_cD ();

	if (exdebug)
		fprintf (stderr, "creat_Decl: for %s\n", symbol[r->tok]);

	for (i = 0; i < r->np; i++)
		for (j = 0; j < r->nrb[i]; j++) {
			rb = &r->rb[i][j];
			if (rb->type == ID && not_decl (rb->tok, rb->num))
				;
			if (exdebug) {
				fprintf (stderr, "	sym num ndecl %s %d %d\n", symbol[rb->tok], rb->num, cD.ndecl);
			}
		}

	if (cD.ndecl > node_max)
		node_max = cD.ndecl;

	d = (Decl*) U_malloc (sizeof (Decl));
	d->ndecl = cD.ndecl;
	d->decl = (int*) U_malloc (sizeof (int*) * d->ndecl);
	d->num = (int*) U_malloc (sizeof (int*) * d->ndecl);
	for (i = 0; i < d->ndecl; i++) {
		d->decl[i] = cD.decl[i];
		d->num[i] = cD.num[i];
	}

	return d;
}

init_cR ()
{
	int i;

	bzero (&cR, sizeof (cR));

	cR.tok = -1;
	cR.np = 0;
	for (i = 0; i < MAXPROD; i++) {
		cR.nrb[i] = 0;
		cR.sys_act[i] = 1;
	}
}

init_cD ()
{
	bzero (&cD, sizeof (cD));
	cD.ndecl = 0;
}

Rule *copy_cR ()
{
	int i, j;
	Rule *r;

	r = (Rule*) U_malloc (sizeof (Rule));

	r->tok = cR.tok;
	r->np = cR.np;

	r->nrb = (int*) U_malloc (sizeof (int) * r->np);
	r->act = (char**) U_malloc (sizeof (char*) * r->np);
	r->sys_act = (int*) U_malloc (sizeof (int) * r->np);
	for (i = 0; i < r->np; i++) {
		r->nrb[i] = cR.nrb[i];
		r->act[i] = cR.act[i];
		r->sys_act[i] = cR.sys_act[i];
		r->rb[i] = (Rbody*) U_malloc (sizeof (Rbody) * r->nrb[i]);
		for (j= 0; j < r->nrb[i]; j++) 
			r->rb[i][j] = cR.rb[i][j];
	}

	return r;
}

int install (sym)
char *sym;
{
	if (get_symbol (sym) > 0)
		fatal ("install: symbol is already in table");

	symbol[tok] = sym;
	Symbol[tok] = to_Symbol (sym);
	type[tok] = DEF;

	if (exdebug)
		show_entry ("install", tok);

	tok++;

	return tok-1;
}

show_entry (str, tok)
char *str;
int tok;
{
	fprintf (stderr, "show_entry: %s: tok s S type %d %s %s %d\n",
	                              str, tok, symbol[tok], Symbol[tok], type[tok]);
}

/***********************************************************************/
is_decsym (ltok)
int ltok;
{
	if (D[ltok] != (Decl*) 0
	|| (E[ltok] != (Exte*) 0
	    && (E[ltok]->add != (char*) 0 || E[ltok]->node)))
		return 1;
	else
		return 0;
}

is_notdecsym (ltok)
int ltok;
{
	if (D[ltok] == (Decl*) 0
	&& (E[ltok] == (Exte*) 0
	    || (E[ltok]->add == (char*) 0 && E[ltok]->node == 0)))
		return 1;
	else
		return 0;
}

is_usedef (ltok)
{
	if (E[ltok] && E[ltok]->use_def)
		return 1;
	else
		return 0;
}

is_notusedef (ltok)
{
	if (E[ltok] == (Exte*) 0 || E[ltok]->use_def == 0)
		return 1;
	else
		return 0;
}
/***********************************************************************/

Exte *alloc_Exte ()
{
	Exte *exte;

	exte = (Exte*) U_malloc (sizeof (Exte));
	bzero (exte, sizeof (Exte));

	return exte;
}
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 52
# define YYLAST 229
int yyact[]={

    36,    10,    11,    12,     9,    59,    13,     5,     6,     3,
     7,    59,    32,    42,    28,    64,    29,    25,    22,    15,
    46,    30,    16,    70,    68,    66,    25,    57,    47,    53,
    18,    63,    49,    27,    23,    69,    65,    34,    48,    20,
    35,    26,    17,     8,     4,    31,    19,    14,     2,     1,
    24,     0,     0,     0,     0,     0,    33,     0,     0,     0,
    41,     0,     0,    43,     0,     0,     0,     0,    50,     0,
     0,     0,     0,     0,     0,     0,    51,     0,     0,     0,
    61,    52,    62,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    67,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    54,
     0,    55,     0,    56,     0,     0,     0,     0,     0,    58,
     0,     0,    21,     0,     0,     0,    60,     0,     0,     0,
     0,     0,    60,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    40,    37,    38,    39,    44,     0,    45,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    28,     0,    29 };
int yypact[]={

 -1000, -1000,  -262,  -239, -1000,  -235, -1000, -1000,   -30, -1000,
 -1000, -1000, -1000, -1000,  -106,   -65, -1000,  -243,  -236,  -259,
 -1000,   -65, -1000, -1000,   -93, -1000,   -31, -1000,   -74,  -237,
   -34, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,  -243, -1000, -1000, -1000, -1000, -1000, -1000,  -118,
  -118, -1000,  -118,   -28, -1000, -1000, -1000, -1000,  -242, -1000,
   -98,   -28,   -28, -1000,  -112,  -101, -1000, -1000, -1000,  -102,
 -1000 };
int yypgo[]={

     0,    34,    50,    27,    49,    48,    47,    46,    45,    44,
    43,    42,    41,    33,    40,    32,    29,    39,    38,    37,
    36,    35 };
int yyr1[]={

     0,     7,     4,     8,     8,     5,     5,     9,     9,     9,
     9,    10,    10,    10,    10,    10,    11,    11,    12,    12,
    12,    13,    13,    13,    13,    14,     6,     6,    18,    17,
    19,    17,    15,    15,    15,    15,    15,    20,     3,    21,
     3,    16,    16,    16,    16,     1,     1,     2,     2,     2,
     2,     2 };
int yyr2[]={

     0,     1,    10,     3,     0,     0,     4,     5,     3,     3,
     6,     2,     2,     2,     2,     2,     0,     7,     2,     5,
     7,     5,     5,     5,     5,     1,    10,     4,     1,    10,
     1,     8,     0,     5,     5,     5,     5,     1,     7,     1,
     9,     0,     5,     7,     5,     1,     4,     3,     5,     5,
     5,     5 };
int yychk[]={

 -1000,    -4,    -5,   271,    -9,   269,   270,   272,   -10,   266,
   263,   264,   265,   268,    -6,   258,   257,   -11,    60,    -7,
   -17,   258,   124,    -1,    -2,    91,   -12,   -13,   257,   259,
   257,    -8,   271,    -1,   -19,   -14,    93,   276,   277,   278,
   275,   -13,    44,    -1,   260,   262,   257,    62,   -18,   -15,
   -15,   -13,   -15,   -16,   257,   259,   261,    -3,   267,   123,
   274,   -16,   -16,    59,   257,   -20,   123,    -3,   125,   -21,
   125 };
int yydef[]={

     5,    -2,     0,     0,     6,     0,     8,     9,    16,    11,
    12,    13,    14,    15,     1,    45,     7,     0,     0,     4,
    27,    45,    30,    25,     0,    47,    10,    18,    45,     0,
     0,     2,     3,    28,    32,    32,    46,    48,    49,    50,
    51,    19,     0,    21,    22,    24,    23,    17,    32,    41,
    41,    20,    41,    31,    33,    34,    35,    36,     0,    37,
     0,    26,    29,    44,    42,     0,    39,    43,    38,     0,
    40 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"IDENTIFIER",	257,
	"C_IDENTIFIER",	258,
	"L_IDENTIFIER",	259,
	"STRING",	260,
	"KLIST",	261,
	"NUMBER",	262,
	"LEFT",	263,
	"RIGHT",	264,
	"NONASSOC",	265,
	"TOKEN",	266,
	"PREC",	267,
	"TYPE",	268,
	"START",	269,
	"UNION",	270,
	"MARK",	271,
	"LCURL",	272,
	"RCURL",	273,
	"<",	60,
	">",	62,
	",",	44,
	"|",	124,
	"{",	123,
	"}",	125,
	";",	59,
	"[",	91,
	"]",	93,
	"EOSTRING",	274,
	"ENPSTRING",	275,
	"EASTRING",	276,
	"EDSTRING",	277,
	"ENSTRING",	278,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"spec : defs MARK rules",
	"spec : defs MARK rules tail",
	"tail : MARK",
	"tail : /* empty */",
	"defs : /* empty */",
	"defs : defs def",
	"def : START IDENTIFIER",
	"def : UNION",
	"def : LCURL",
	"def : rword tag nlist",
	"rword : TOKEN",
	"rword : LEFT",
	"rword : RIGHT",
	"rword : NONASSOC",
	"rword : TYPE",
	"tag : /* empty */",
	"tag : '<' IDENTIFIER '>'",
	"nlist : nmno",
	"nlist : nlist nmno",
	"nlist : nlist ',' nmno",
	"nmno : IDENTIFIER opt_exten",
	"nmno : IDENTIFIER STRING",
	"nmno : L_IDENTIFIER IDENTIFIER",
	"nmno : IDENTIFIER NUMBER",
	"rules : C_IDENTIFIER opt_exten",
	"rules : C_IDENTIFIER opt_exten rbody prec",
	"rules : rules rule",
	"rule : C_IDENTIFIER opt_exten",
	"rule : C_IDENTIFIER opt_exten rbody prec",
	"rule : '|'",
	"rule : '|' rbody prec",
	"rbody : /* empty */",
	"rbody : rbody IDENTIFIER",
	"rbody : rbody L_IDENTIFIER",
	"rbody : rbody KLIST",
	"rbody : rbody act",
	"act : '{'",
	"act : '{' '}'",
	"act : EOSTRING '{'",
	"act : EOSTRING '{' '}'",
	"prec : /* empty */",
	"prec : PREC IDENTIFIER",
	"prec : PREC IDENTIFIER act",
	"prec : prec ';'",
	"opt_exten : /* empty */",
	"opt_exten : exten ']'",
	"exten : '['",
	"exten : exten EASTRING",
	"exten : exten EDSTRING",
	"exten : exten ENSTRING",
	"exten : exten ENPSTRING",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 71 "ypp.y"
{
			dump_all ();
		} break;
case 3:
# line 78 "ypp.y"
{
			printf ("\n%%%%");
			copy_file();
		} break;
case 7:
# line 90 "ypp.y"
{
		printf ("\n%%start %s\n\n", yypvt[-0].str);
	} break;
case 8:
# line 94 "ypp.y"
{
		p_UNION();
		niy();
	} break;
case 9:
# line 99 "ypp.y"
{
		p_LCURL();
	} break;
case 17:
# line 114 "ypp.y"
{
			niy();
	} break;
case 19:
# line 122 "ypp.y"
{
			niy("nlist1");
	} break;
case 20:
# line 126 "ypp.y"
{
			niy("nlist2");
	} break;
case 21:
# line 132 "ypp.y"
{
			Symbol[tok] = yypvt[-1].str;
			symbol[tok] = to_symbol (yypvt[-1].str);
			type[tok] = TERM;
			E[tok] = yypvt[-0].exte;

			tok++;
		} break;
case 22:
# line 141 "ypp.y"
{
			Symbol[tok] = yypvt[-1].str;
			symbol[tok] = to_symbol (yypvt[-1].str);
			type[tok] = TERM;
			Lymbol[tok] = yypvt[-0].str;

			tok++;
		} break;
case 23:
# line 150 "ypp.y"
{
			int ltok;

			ltok = (int) *(yypvt[-1].str+1);
			Lymbol[ltok] = yypvt[-1].str;
			Symbol[ltok] = yypvt[-0].str;
			symbol[ltok] = to_symbol (yypvt[-0].str);
			type[ltok] = LIT;
		} break;
case 24:
# line 160 "ypp.y"
{
			fatal ("no NUMBERs allowed in 'nmno'");
		} break;
case 25:
# line 168 "ypp.y"
{
			rule_init (yypvt[-1].str, yypvt[-0].exte);
		} break;
case 28:
# line 176 "ypp.y"
{
			rule_init (yypvt[-1].str, yypvt[-0].exte);
		} break;
case 30:
# line 181 "ypp.y"
{
			inc_nprod ();
		} break;
case 33:
# line 189 "ypp.y"
{
			add_rbody (yypvt[-0].str, ID);
		} break;
case 34:
# line 193 "ypp.y"
{
			add_rbody (yypvt[-0].str, ID);
		} break;
case 35:
# line 197 "ypp.y"
{
			yypvt[-0].str[strlen (yypvt[-0].str) - 5] = '\0';
			yypvt[-0].str = to_symbol (yypvt[-0].str);
			strcat (yypvt[-0].str, "List");

			symbol[tok] = yypvt[-0].str;
			Symbol[tok] = to_Symbol (yypvt[-0].str);
			type[tok] = LIST;

			tok++;

			add_rbody (yypvt[-0].str, ID);
		} break;
case 36:
# line 211 "ypp.y"
{
			add_rbody (yypvt[-0].str, ACT);
		} break;
case 37:
# line 217 "ypp.y"
{
			cR.act[cR.np] = get_act ();
		} break;
case 38:
# line 221 "ypp.y"
{
			yyval.str = cR.act[cR.np];
		} break;
case 39:
# line 225 "ypp.y"
{
			cR.act[cR.np] = get_act ();
			cR.sys_act[cR.np] = 0;
		} break;
case 40:
# line 230 "ypp.y"
{
			yyval.str = cR.act[cR.np];
		} break;
case 42:
# line 237 "ypp.y"
{
			fprintf (stderr, "NOT IMPLEMENTED YET\n");
			exit (7);
		} break;
case 43:
# line 242 "ypp.y"
{
			fprintf (stderr, "NOT IMPLEMENTED YET\n");
			exit (7);
		} break;
case 44:
# line 247 "ypp.y"
{
			inc_nprod ();
			R [cR.tok] = copy_cR ();
			D [cR.tok] = creat_Decl (&cR);
		} break;
case 45:
# line 258 "ypp.y"
{
		yyval.exte = (Exte*) 0;
	} break;
case 47:
# line 266 "ypp.y"
{
		yyval.exte = alloc_Exte ();
	} break;
case 48:
# line 270 "ypp.y"
{
		if (yypvt[-1].exte->add == (char*) 0) {
			yypvt[-1].exte->add = yypvt[-0].str;
			yyval.exte = yypvt[-1].exte;
		}
		else
			fatal ("A| repeated in extension");
	} break;
case 49:
# line 279 "ypp.y"
{
		if (yypvt[-1].exte->use_def == 0) {
			yypvt[-1].exte->use_def = 1;
			yyval.exte = yypvt[-1].exte;
		}
		else
			fatal ("D| repeated in extension");
	} break;
case 50:
# line 288 "ypp.y"
{
		if (yypvt[-1].exte->node == 0) {
			yypvt[-1].exte->node = 1;
			yyval.exte = yypvt[-1].exte;
		}
		else
			fatal ("N| repeated in extension");
	} break;
case 51:
# line 297 "ypp.y"
{
		if (yypvt[-1].exte->np == 0) {
			yypvt[-1].exte->np = 1;
			yyval.exte = yypvt[-1].exte;
		}
		else
			fatal ("NP| repeated in extension");
	} break;
	}
	goto yystack;		/* reset registers in driver code */
}
